/* Generated By:JavaCC: Do not edit this line. Nexus.java */
package Parser.nexus;
//import Parse.*;
import AccordionTreeDrawer.Tree;
import AccordionTreeDrawer.TreeNode;
import java.util.*;

/** 
 * A static class used for parsing a Nexus format file containing multiple trees.
 * Given a Nexus tree file and an index number, the parser will find the corresponding 
 * tree with the given index number and initiate a tree object for it. 
 * @author Yunhong Zhou
 */

public class Nexus implements NexusConstants {

  /** the target tree to be initiated by the parser */
  private static Tree tree;

  /** the current TreeNode that the parser is visiting and initiating */
  private static TreeNode current_node;

  /** a helper TreeNode field */
  private static TreeNode tn;

  /** the index of the tree to be initiated from the collection of trees in the nexus file */
  private static int index;

  /** flag is true if the parser is visiting the target tree */
  private static boolean flag;

  private static int cnt;

  /** 
   * transflag is true if the nexus file has a translation header. 
   * If transflag is true, then we need to translate the leaf label to its real name.
   */
  private static boolean transflag = false;

  /** the hashtable ht_trans stores entries for label translation process */
  private static Hashtable ht_trans;

  /** 
   * function parseTree initiates field tree, call function Input to parse the input.
   * @param t Tree t will be initiated throught the parsing process 
   * @param index The index of the tree to be initiated from parsing 
   * @author Yunhong Zhou
   */
  public void parseTree(Tree t, int index) {
    tree = t;
    this.index = index;
    try{ Input(); }
    catch( ParseException e ){
        if(t.getName() == null)
          System.out.println("Parsing error with input!");
        else
          System.out.println("Parsing error with input file " + t.getName());
        e.printStackTrace();
    }
  }

  static final public void Input() throws ParseException {
  cnt = 0;
    label_1:
    while (true) {
      if (jj_2_1(2)) {
        jj_consume_token(token_tree);
        tree_newick();
      } else if (jj_2_2(2)) {
        jj_consume_token(translate);
        trans_statement();
      } else if (jj_2_3(2)) {
        jj_consume_token(unquoted_string);
        other_statement();
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
      if (jj_2_4(2)) {
        ;
      } else {
        break label_1;
      }
    }
    jj_consume_token(0);
  }

  static final public void other_statement() throws ParseException {
    label_2:
    while (true) {
      if (jj_2_5(2)) {
        ;
      } else {
        break label_2;
      }
      if (jj_2_6(2)) {
        jj_consume_token(unquoted_string);
      } else if (jj_2_7(2)) {
        jj_consume_token(quoted_string);
      } else if (jj_2_8(2)) {
        jj_consume_token(double_number);
      } else if (jj_2_9(2)) {
        jj_consume_token(token_tree);
      } else if (jj_2_10(2)) {
        jj_consume_token(equal);
      } else if (jj_2_11(2)) {
        jj_consume_token(lparen);
      } else if (jj_2_12(2)) {
        jj_consume_token(rparen);
      } else if (jj_2_13(2)) {
        jj_consume_token(comma);
      } else if (jj_2_14(2)) {
        jj_consume_token(colon);
      } else {
        jj_consume_token(-1);
        throw new ParseException();
      }
    }
    jj_consume_token(semicolon);
  }

/** 
 * function trans_statement generates a hash table for label translation
 */
  static final public void trans_statement() throws ParseException {
  String s_key, s_value;
  transflag = true;
  ht_trans = new Hashtable();
  Hashtable ht_values = new Hashtable();
    label_3:
    while (true) {
      s_key = label_text();
      s_value = label_text();
      if (jj_2_15(2)) {
        jj_consume_token(comma);
      } else {
        ;
      }
      String prev_key = (String)(ht_values.get(s_value));
      if(prev_key != null){
        StringBuffer sb = new StringBuffer(s_value);
        sb.append(" ").append(s_key);
        ht_trans.put(s_key, sb.toString());

        if(!prev_key.equals("-1")){
          sb = new StringBuffer(s_value);
          sb.append(" ").append(prev_key);
          ht_trans.put(prev_key, sb.toString());
          ht_values.put(s_value, "-1");
        }

      }else{
        ht_trans.put(s_key, s_value);
        ht_values.put(s_value, s_key);
      }
      if (jj_2_16(2)) {
        ;
      } else {
        break label_3;
      }
    }
    jj_consume_token(semicolon);
    ht_values = null;
  }

/** this function is responsible for parsing one tree */
  static final public void tree_newick() throws ParseException {
  String s;
  double len;
    jj_consume_token(unquoted_string);
    jj_consume_token(equal);
    cnt++; flag = (cnt == index)?true:false;
    if(flag)current_node = tree.getRoot();
    descendant_list();
    if (jj_2_17(2)) {
      s = label();
                  if(flag)current_node.setName(s);
                  //System.out.println("Name: " + s);

    } else {
      ;
    }
    if (jj_2_18(2)) {
      jj_consume_token(colon);
      len = branch_length();
                                    if(flag)current_node.setWeight(len);
                                //System.out.println("weight: " + len); 

    } else {
      ;
    }
    jj_consume_token(semicolon);
  }

  static final public void descendant_list() throws ParseException {
    jj_consume_token(lparen);
             if(flag){
        tn = new TreeNode();
        current_node.addChild(tn);
        current_node = tn;
        }
    subtree();
    label_4:
    while (true) {
      if (jj_2_19(2)) {
        ;
      } else {
        break label_4;
      }
      jj_consume_token(comma);
              if(flag){
          tn = new TreeNode();
          current_node.addChild(tn);
          current_node = tn;
          }
      subtree();
    }
    jj_consume_token(rparen);
  }

/** function subtree will set name, length and weight for each tree node */
  static final public void subtree() throws ParseException {
  String s;
  double len;
    if (jj_2_24(2)) {
      descendant_list();

      if (jj_2_20(2)) {
        s = label();
                  if(flag)current_node.setName(s);
                  //System.out.println("Name: " + s); 

      } else {
        ;
      }
      if (jj_2_21(2)) {
        jj_consume_token(colon);
        len = branch_length();
                                    if(flag)current_node.setWeight(len);
                                //System.out.println("Weight: " + len);

      } else {
        ;
      }
         if(flag)current_node = current_node.parent();
    } else {
      if (jj_2_22(2)) {
        s = label();
                  if(flag)current_node.setName(s);
                  //System.out.println("Name: " + s); 

      } else {
        ;
      }
      if (jj_2_23(2)) {
        jj_consume_token(colon);
        len = branch_length();
                                    if(flag)current_node.setWeight(len);
                                //System.out.println("Weight: " + len);

      } else {
        ;
      }
         if(flag)current_node = current_node.parent();
    }
  }

/** get the real name for each label, translate if necessary */
  static final public String label() throws ParseException {
  String s, s_trans = null; Token t;
    s = label_text();
                     if(transflag && flag){
                       s_trans = (String)ht_trans.get(s);
                       if(s_trans != null){
                         {if (true) return s_trans;}
                       }else {if (true) return s;}

                     }else {if (true) return s;}
                     // TODO : integer index

    throw new Error("Missing return statement in function");
  }

/** 
 * for each unquoted label, we need to replace '_' by ' '.
 * for each quoted label, we remove double quotes from the string.
 */
  static final public String label_text() throws ParseException {
  String s; Token t;
    if (jj_2_25(2)) {
      t = jj_consume_token(unquoted_string);
                          s = new String(t.toString());
                          {if (true) return s.replace('_', ' ');}
    } else if (jj_2_26(2)) {
      t = jj_consume_token(quoted_string);
                        s = new String(t.toString());
                        {if (true) return s.substring(1, s.length()-1).replaceAll("[\n\r\f]", "");}
    } else if (jj_2_27(2)) {
      t = jj_consume_token(double_number);
                        {if (true) return new String(t.toString());}
    } else {
      jj_consume_token(-1);
      throw new ParseException();
    }
    throw new Error("Missing return statement in function");
  }

  static final public double branch_length() throws ParseException {
  Token t;
    t = jj_consume_token(double_number);
                        {if (true) return Double.parseDouble(t.toString());}
    throw new Error("Missing return statement in function");
  }

  static final private boolean jj_2_1(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_1(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(0, xla); }
  }

  static final private boolean jj_2_2(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_2(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(1, xla); }
  }

  static final private boolean jj_2_3(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_3(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(2, xla); }
  }

  static final private boolean jj_2_4(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_4(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(3, xla); }
  }

  static final private boolean jj_2_5(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_5(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(4, xla); }
  }

  static final private boolean jj_2_6(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_6(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(5, xla); }
  }

  static final private boolean jj_2_7(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_7(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(6, xla); }
  }

  static final private boolean jj_2_8(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_8(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(7, xla); }
  }

  static final private boolean jj_2_9(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_9(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(8, xla); }
  }

  static final private boolean jj_2_10(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_10(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(9, xla); }
  }

  static final private boolean jj_2_11(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_11(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(10, xla); }
  }

  static final private boolean jj_2_12(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_12(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(11, xla); }
  }

  static final private boolean jj_2_13(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_13(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(12, xla); }
  }

  static final private boolean jj_2_14(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_14(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(13, xla); }
  }

  static final private boolean jj_2_15(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_15(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(14, xla); }
  }

  static final private boolean jj_2_16(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_16(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(15, xla); }
  }

  static final private boolean jj_2_17(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_17(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(16, xla); }
  }

  static final private boolean jj_2_18(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_18(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(17, xla); }
  }

  static final private boolean jj_2_19(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_19(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(18, xla); }
  }

  static final private boolean jj_2_20(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_20(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(19, xla); }
  }

  static final private boolean jj_2_21(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_21(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(20, xla); }
  }

  static final private boolean jj_2_22(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_22(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(21, xla); }
  }

  static final private boolean jj_2_23(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_23(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(22, xla); }
  }

  static final private boolean jj_2_24(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_24(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(23, xla); }
  }

  static final private boolean jj_2_25(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_25(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(24, xla); }
  }

  static final private boolean jj_2_26(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_26(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(25, xla); }
  }

  static final private boolean jj_2_27(int xla) {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    try { return !jj_3_27(); }
    catch(LookaheadSuccess ls) { return true; }
    finally { jj_save(26, xla); }
  }

  static final private boolean jj_3_18() {
    if (jj_scan_token(colon)) return true;
    if (jj_3R_10()) return true;
    return false;
  }

  static final private boolean jj_3_17() {
    if (jj_3R_9()) return true;
    return false;
  }

  static final private boolean jj_3_9() {
    if (jj_scan_token(token_tree)) return true;
    return false;
  }

  static final private boolean jj_3R_10() {
    if (jj_scan_token(double_number)) return true;
    return false;
  }

  static final private boolean jj_3R_5() {
    if (jj_scan_token(unquoted_string)) return true;
    return false;
  }

  static final private boolean jj_3_27() {
    if (jj_scan_token(double_number)) return true;
    return false;
  }

  static final private boolean jj_3_26() {
    if (jj_scan_token(quoted_string)) return true;
    return false;
  }

  static final private boolean jj_3_14() {
    if (jj_scan_token(colon)) return true;
    return false;
  }

  static final private boolean jj_3_25() {
    if (jj_scan_token(unquoted_string)) return true;
    return false;
  }

  static final private boolean jj_3R_8() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_25()) {
    jj_scanpos = xsp;
    if (jj_3_26()) {
    jj_scanpos = xsp;
    if (jj_3_27()) return true;
    }
    }
    return false;
  }

  static final private boolean jj_3_8() {
    if (jj_scan_token(double_number)) return true;
    return false;
  }

  static final private boolean jj_3_13() {
    if (jj_scan_token(comma)) return true;
    return false;
  }

  static final private boolean jj_3R_9() {
    if (jj_3R_8()) return true;
    return false;
  }

  static final private boolean jj_3_12() {
    if (jj_scan_token(rparen)) return true;
    return false;
  }

  static final private boolean jj_3_15() {
    if (jj_scan_token(comma)) return true;
    return false;
  }

  static final private boolean jj_3_7() {
    if (jj_scan_token(quoted_string)) return true;
    return false;
  }

  static final private boolean jj_3_16() {
    if (jj_3R_8()) return true;
    if (jj_3R_8()) return true;
    return false;
  }

  static final private boolean jj_3_23() {
    if (jj_scan_token(colon)) return true;
    if (jj_3R_10()) return true;
    return false;
  }

  static final private boolean jj_3R_6() {
    Token xsp;
    if (jj_3_16()) return true;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_16()) { jj_scanpos = xsp; break; }
    }
    return false;
  }

  static final private boolean jj_3_22() {
    if (jj_3R_9()) return true;
    return false;
  }

  static final private boolean jj_3_11() {
    if (jj_scan_token(lparen)) return true;
    return false;
  }

  static final private boolean jj_3R_13() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_22()) jj_scanpos = xsp;
    xsp = jj_scanpos;
    if (jj_3_23()) jj_scanpos = xsp;
    return false;
  }

  static final private boolean jj_3_21() {
    if (jj_scan_token(colon)) return true;
    if (jj_3R_10()) return true;
    return false;
  }

  static final private boolean jj_3_20() {
    if (jj_3R_9()) return true;
    return false;
  }

  static final private boolean jj_3_10() {
    if (jj_scan_token(equal)) return true;
    return false;
  }

  static final private boolean jj_3_24() {
    if (jj_3R_12()) return true;
    return false;
  }

  static final private boolean jj_3R_11() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_24()) {
    jj_scanpos = xsp;
    if (jj_3R_13()) return true;
    }
    return false;
  }

  static final private boolean jj_3_5() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_6()) {
    jj_scanpos = xsp;
    if (jj_3_7()) {
    jj_scanpos = xsp;
    if (jj_3_8()) {
    jj_scanpos = xsp;
    if (jj_3_9()) {
    jj_scanpos = xsp;
    if (jj_3_10()) {
    jj_scanpos = xsp;
    if (jj_3_11()) {
    jj_scanpos = xsp;
    if (jj_3_12()) {
    jj_scanpos = xsp;
    if (jj_3_13()) {
    jj_scanpos = xsp;
    if (jj_3_14()) return true;
    }
    }
    }
    }
    }
    }
    }
    }
    return false;
  }

  static final private boolean jj_3_6() {
    if (jj_scan_token(unquoted_string)) return true;
    return false;
  }

  static final private boolean jj_3R_7() {
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_5()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(semicolon)) return true;
    return false;
  }

  static final private boolean jj_3_3() {
    if (jj_scan_token(unquoted_string)) return true;
    if (jj_3R_7()) return true;
    return false;
  }

  static final private boolean jj_3_2() {
    if (jj_scan_token(translate)) return true;
    if (jj_3R_6()) return true;
    return false;
  }

  static final private boolean jj_3_1() {
    if (jj_scan_token(token_tree)) return true;
    if (jj_3R_5()) return true;
    return false;
  }

  static final private boolean jj_3_4() {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3_1()) {
    jj_scanpos = xsp;
    if (jj_3_2()) {
    jj_scanpos = xsp;
    if (jj_3_3()) return true;
    }
    }
    return false;
  }

  static final private boolean jj_3_19() {
    if (jj_scan_token(comma)) return true;
    if (jj_3R_11()) return true;
    return false;
  }

  static final private boolean jj_3R_12() {
    if (jj_scan_token(lparen)) return true;
    if (jj_3R_11()) return true;
    Token xsp;
    while (true) {
      xsp = jj_scanpos;
      if (jj_3_19()) { jj_scanpos = xsp; break; }
    }
    if (jj_scan_token(rparen)) return true;
    return false;
  }

  static private boolean jj_initialized_once = false;
  static public NexusTokenManager token_source;
  static SimpleCharStream jj_input_stream;
  static public Token token, jj_nt;
  static private int jj_ntk;
  static private Token jj_scanpos, jj_lastpos;
  static private int jj_la;
  static public boolean lookingAhead = false;
  static private boolean jj_semLA;
  static private int jj_gen;
  static final private int[] jj_la1 = new int[0];
  static private int[] jj_la1_0;
  static private int[] jj_la1_1;
  static {
      jj_la1_0();
      jj_la1_1();
   }
   private static void jj_la1_0() {
      jj_la1_0 = new int[] {};
   }
   private static void jj_la1_1() {
      jj_la1_1 = new int[] {};
   }
  static final private JJCalls[] jj_2_rtns = new JJCalls[27];
  static private boolean jj_rescan = false;
  static private int jj_gc = 0;

  public Nexus(java.io.InputStream stream) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  You must");
      System.out.println("       either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new NexusTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  static public void ReInit(java.io.InputStream stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public Nexus(java.io.Reader stream) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  You must");
      System.out.println("       either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    jj_input_stream = new SimpleCharStream(stream, 1, 1);
    token_source = new NexusTokenManager(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  static public void ReInit(java.io.Reader stream) {
    jj_input_stream.ReInit(stream, 1, 1);
    token_source.ReInit(jj_input_stream);
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public Nexus(NexusTokenManager tm) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  You must");
      System.out.println("       either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  public void ReInit(NexusTokenManager tm) {
    token_source = tm;
    token = new Token();
    jj_ntk = -1;
    jj_gen = 0;
    for (int i = 0; i < 0; i++) jj_la1[i] = -1;
    for (int i = 0; i < jj_2_rtns.length; i++) jj_2_rtns[i] = new JJCalls();
  }

  static final private Token jj_consume_token(int kind) throws ParseException {
    Token oldToken;
    if ((oldToken = token).next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    if (token.kind == kind) {
      jj_gen++;
      if (++jj_gc > 100) {
        jj_gc = 0;
        for (int i = 0; i < jj_2_rtns.length; i++) {
          JJCalls c = jj_2_rtns[i];
          while (c != null) {
            if (c.gen < jj_gen) c.first = null;
            c = c.next;
          }
        }
      }
      return token;
    }
    token = oldToken;
    jj_kind = kind;
    throw generateParseException();
  }

  static private final class LookaheadSuccess extends java.lang.Error { }
  static final private LookaheadSuccess jj_ls = new LookaheadSuccess();
  static final private boolean jj_scan_token(int kind) {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    if (jj_rescan) {
      int i = 0; Token tok = token;
      while (tok != null && tok != jj_scanpos) { i++; tok = tok.next; }
      if (tok != null) jj_add_error_token(kind, i);
    }
    if (jj_scanpos.kind != kind) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) throw jj_ls;
    return false;
  }

  static final public Token getNextToken() {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    jj_ntk = -1;
    jj_gen++;
    return token;
  }

  static final public Token getToken(int index) {
    Token t = lookingAhead ? jj_scanpos : token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  static final private int jj_ntk() {
    if ((jj_nt=token.next) == null)
      return (jj_ntk = (token.next=token_source.getNextToken()).kind);
    else
      return (jj_ntk = jj_nt.kind);
  }

  static private java.util.Vector jj_expentries = new java.util.Vector();
  static private int[] jj_expentry;
  static private int jj_kind = -1;
  static private int[] jj_lasttokens = new int[100];
  static private int jj_endpos;

  static private void jj_add_error_token(int kind, int pos) {
    if (pos >= 100) return;
    if (pos == jj_endpos + 1) {
      jj_lasttokens[jj_endpos++] = kind;
    } else if (jj_endpos != 0) {
      jj_expentry = new int[jj_endpos];
      for (int i = 0; i < jj_endpos; i++) {
        jj_expentry[i] = jj_lasttokens[i];
      }
      boolean exists = false;
      for (java.util.Enumeration e = jj_expentries.elements(); e.hasMoreElements();) {
        int[] oldentry = (int[])(e.nextElement());
        if (oldentry.length == jj_expentry.length) {
          exists = true;
          for (int i = 0; i < jj_expentry.length; i++) {
            if (oldentry[i] != jj_expentry[i]) {
              exists = false;
              break;
            }
          }
          if (exists) break;
        }
      }
      if (!exists) jj_expentries.addElement(jj_expentry);
      if (pos != 0) jj_lasttokens[(jj_endpos = pos) - 1] = kind;
    }
  }

  static public ParseException generateParseException() {
    jj_expentries.removeAllElements();
    boolean[] la1tokens = new boolean[38];
    for (int i = 0; i < 38; i++) {
      la1tokens[i] = false;
    }
    if (jj_kind >= 0) {
      la1tokens[jj_kind] = true;
      jj_kind = -1;
    }
    for (int i = 0; i < 0; i++) {
      if (jj_la1[i] == jj_gen) {
        for (int j = 0; j < 32; j++) {
          if ((jj_la1_0[i] & (1<<j)) != 0) {
            la1tokens[j] = true;
          }
          if ((jj_la1_1[i] & (1<<j)) != 0) {
            la1tokens[32+j] = true;
          }
        }
      }
    }
    for (int i = 0; i < 38; i++) {
      if (la1tokens[i]) {
        jj_expentry = new int[1];
        jj_expentry[0] = i;
        jj_expentries.addElement(jj_expentry);
      }
    }
    jj_endpos = 0;
    jj_rescan_token();
    jj_add_error_token(0, 0);
    int[][] exptokseq = new int[jj_expentries.size()][];
    for (int i = 0; i < jj_expentries.size(); i++) {
      exptokseq[i] = (int[])jj_expentries.elementAt(i);
    }
    return new ParseException(token, exptokseq, tokenImage);
  }

  static final public void enable_tracing() {
  }

  static final public void disable_tracing() {
  }

  static final private void jj_rescan_token() {
    jj_rescan = true;
    for (int i = 0; i < 27; i++) {
      JJCalls p = jj_2_rtns[i];
      do {
        if (p.gen > jj_gen) {
          jj_la = p.arg; jj_lastpos = jj_scanpos = p.first;
          switch (i) {
            case 0: jj_3_1(); break;
            case 1: jj_3_2(); break;
            case 2: jj_3_3(); break;
            case 3: jj_3_4(); break;
            case 4: jj_3_5(); break;
            case 5: jj_3_6(); break;
            case 6: jj_3_7(); break;
            case 7: jj_3_8(); break;
            case 8: jj_3_9(); break;
            case 9: jj_3_10(); break;
            case 10: jj_3_11(); break;
            case 11: jj_3_12(); break;
            case 12: jj_3_13(); break;
            case 13: jj_3_14(); break;
            case 14: jj_3_15(); break;
            case 15: jj_3_16(); break;
            case 16: jj_3_17(); break;
            case 17: jj_3_18(); break;
            case 18: jj_3_19(); break;
            case 19: jj_3_20(); break;
            case 20: jj_3_21(); break;
            case 21: jj_3_22(); break;
            case 22: jj_3_23(); break;
            case 23: jj_3_24(); break;
            case 24: jj_3_25(); break;
            case 25: jj_3_26(); break;
            case 26: jj_3_27(); break;
          }
        }
        p = p.next;
      } while (p != null);
    }
    jj_rescan = false;
  }

  static final private void jj_save(int index, int xla) {
    JJCalls p = jj_2_rtns[index];
    while (p.gen > jj_gen) {
      if (p.next == null) { p = p.next = new JJCalls(); break; }
      p = p.next;
    }
    p.gen = jj_gen + xla - jj_la; p.first = token; p.arg = xla;
  }

  static final class JJCalls {
    int gen;
    Token first;
    int arg;
    JJCalls next;
  }

}
